
#ifndef __SOP_SBC_h__
#define __SOP_SBC_h__

#include <SOP/SOP_Node.h>

class SOP_SBC_capt : public SOP_Node
{
public:
    static PRM_Template    myTemplateList[];
    static OP_Node    *myConstructor(OP_Network*, const char *,
                  OP_Operator *);


protected:
       SOP_SBC_capt(OP_Network *net, const char *name, OP_Operator *op);
    virtual ~SOP_SBC_capt();

    virtual unsigned      disableParms();
    virtual const char          *inputLabel(unsigned int) const;

    // Method to cook geometry for the SOP
    virtual OP_ERROR       cookMySop(OP_Context &context);

    // This method is used to generate geometry for a "guide".
    virtual OP_ERROR             cookMyGuide1(OP_Context &context);

private:

  inline float absolute(float v)          { return v>=0?v:v*-1; }

//parameters
  int              PRECONVEX()      { return evalInt  ("pre_convexRest", 0, 0); }
  //int              ACC()          { return evalInt  ("accurate_weights", 0, 0); }
  //int              FULLCHECKS()     { return evalInt  ("full_checks", 0, 0); }
  int              USETHRES()       { return evalInt  ("usethres", 0, 0); }
  float            THRES()        { return evalFloat ("thres", 0, 0); }

//functions
  float             calcWeights(UT_Vector3 pos, const GEO_Primitive *prim, UT_FloatArray &numerators);
  float             calcAlpha(const GEO_Primitive *prim, int i, UT_Vector3 vF, UT_Vector3 pos, float theta);
  float             calcTheta(UT_Vector3 pos, const GEO_Primitive *prim, int i, UT_Vector3 vF);
  UT_Vector3        calcFaceNormal(UT_Vector3 pos, const GEO_Primitive *prim);

  int               cyclicMod(int v, int n);

};

#endif
