
#ifndef __SOP_SBC_h__
#define __SOP_SBC_h__

#include <SOP/SOP_Node.h>

class SOP_SBC_transfer : public SOP_Node
{
public:
       SOP_SBC_transfer(OP_Network *net, const char *name, OP_Operator *op);
    virtual ~SOP_SBC_transfer();


    static PRM_Template    myTemplateList[];
    static OP_Node    *myConstructor(OP_Network*, const char *,
                  OP_Operator *);


protected:
    virtual unsigned      disableParms();
    virtual const char          *inputLabel(unsigned int) const;

    // Method to cook geometry for the SOP
    virtual OP_ERROR       cookMySop(OP_Context &context);

    // This method is used to generate geometry for a "guide".
    virtual OP_ERROR             cookMyGuide1(OP_Context &context);

private:
  inline float absolute(float v)          { return v>=0?v:v*-1; }

  int     DELATT()                  { return evalInt  (0, 0, 0); }
  void    getATTS(UT_String &str)   { evalString(str, 1, 0, 0); }
  int     NORM()                    { return evalInt  (2, 0, 0); }


};

#endif
